
#include <Wire.h>

byte i2cAddress = 99;  // circuit I2C address - must be changed to the correct address

void setup() {
  Wire.begin();
  Wire.setClock(10000);  // set I2C bus to 10 KHz - this is important!

  Serial.begin(115200);  // set serial monitor to 115200 baud rate
  
  Serial.println(F("---------------------- Robo-Tank pH Circuit Test Sketch ----------------------"));
  Serial.println(F("------------------------------------------------------------------------------"));
  Serial.println(F(""));
  
  float pH = 0;
  pH = getPH();  // this function will get the current pH
}

void loop() {
  // put your main code here, to run repeatedly:
  delay(4000);  // wait 4 seconds until we read pH
  float pH = 0;
  pH = getPH();  // this function will get the current pH
}

float getPH()  // get the current pH
{
  Wire.beginTransmission(i2cAddress);  // start transmission
  Wire.write("R");  // ask for pH
  Wire.write(0);  // send closing byte
  Wire.endTransmission();  // end transmission

  byte count = 0;  // count imcoming bytes
  String i = "";  // create string of incoming data
  Wire.requestFrom(i2cAddress, 8);  // request 8 bytes from pH circuit
  while(Wire.available())    // read the 8 incoming bytes
  { 
    char c = Wire.read(); // receive a byte as character  
    if (count > 0) {i = i + c;}  // ignore first btye and combine remaining into a string
    count++;  // count byte
  }
  float pH = i.toFloat();  // convert pH string to float
  Serial.print(F("pH =   "));
  Serial.println(pH,3);  // print pH to serial monitor
  return pH;  // return pH
}

